#ifndef COMMON_H
#define COMMON_H

/* Includes {{{*/
#include <sys/types.h>
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <pcap.h>
#include <arpa/inet.h>
#include <string.h>
#include <assert.h>
#include "headers.h"
#include "radiotap.h"
#include "crc32.h"
#include "blocks.h"
/*}}}*/

/* Constants {{{*/
#define PCAP_FILTER "udp port 2000"
#define PACKET_SIZE 1562

#define WLANSIZE 28
#define LLCSIZE 8
#define IPSIZE 20 
#define UDPSIZE 8 
#define UDPDATASIZE 1024 

#define BLOCKSIZE 64 
//#define BLOCKSIZE 1 

/*
 * From: http://www.oreillynet.com/pub/a/wireless/2003/08/08/wireless_throughput.html
 */
#define PREAMBLE_US 96

/*}}}*/

/* Constants *that may need to be modified in simulator.c* {{{*/
// TODO Include extra time to send nacks

/*
 * Constants for determining correctness of 
 * retransmission headers.
 */

/* 802.11 */
extern u_char SRC[];
extern u_char BSSID[];
extern u_char DST[];

/* LLC */
extern u_char LLC_ORG[];
extern u_char LLC_TYPE[];

/* IP */
extern u_char IP_SRC[];
extern u_char IP_DST[];
extern uint16_t IP_LEN;

/* UDP */
extern uint16_t UDP_LEN;
extern uint16_t UDP_SRC;
extern uint16_t UDP_DST;

/* Bad blocks */
extern int (*good_blocks)(u_char* packet, int len);

/*}}}*/

#endif
